// ================== MSP430F2xxx A/D10 ͸ LED ǥ ===================
//  CPU : MSP430F2012
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : IAR-MSP430
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(8MHz)
//            SMCLK: DCO(8MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include "msp430x20x2.h"
#include <stdio.h>

// Լ 
void adc10_set(void);						// ADC10 

//  
unsigned adc10_data;						// analog10 interrupt data
int adc10_int_flg = 0;						// analog10 interrupt flag

// ===============================  α׷ ==============================
// [μ]: void
// [] A/D Input 10Bit A1(P1.1) : 0 - AVcc(Է ) 
//        A1 > 1.498V(465) -> LED(P1.0 = 0) ON
// ---------------------------------------------------------------------------
int main(void)
{
unsigned dly;
	
	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 
// 1MHZ  : CALBC1_1MHZ,  CALDCO_1MHZ
// 8MHZ  : CALBC1_8MHZ,  CALDCO_8MHZ
// 12MHZ : CALBC1_12MHZ, CALDCO_12MHZ
// 16MHZ : CALBC1_16MHZ, CALDCO_16MHZ
	BCSCTL1 = CALBC1_8MHZ;					// Set range(0x10f9)
	DCOCTL = CALDCO_8MHZ;					// Set DCO step + modulation(0x10f8)

	adc10_set();						// ADC10 
	P1DIR |= 0x01;						// Set P1.0 to output direction
	P1OUT |= 0x01;						// P1.0 = 0 :: LED OFF
	_EINT();						// Enable interrupts

	while(1){
		adc10_int_flg = 0;
		ADC10CTL0 |= ENC + ADC10SC;			// Sampling and conversion start
		while(adc10_int_flg == 0);			// a/d conversion Ϸ 
		if(adc10_data > 465) P1OUT &= ~0x01;		// P1.0 = 1 :: LED ON
		else P1OUT |= 0x01;				// P1.0 = 0 :: LED OFF
	}
}

// ============================== ADC10  ==================================
// [μ] void
// ----------------------------------------------------------------------------
void adc10_set(void)
{
// Input Channel : a1
// ADC10 Clock divider : / 4	
	ADC10CTL1 = INCH_1+ADC10DIV_3;				// A1 for ADC10CLK/4
// SREFx     : VR+ = AVcc, VR- = AVss
// ADC10SHTx : 16 * ADC1-CLKs
// ADC10SR   : ~200ksps
// REF2.5V   : 1.5V
// REFON     : Reference off 
// ADC10ON   : ADC10 on
// ADC10IE   : interrupt enable
	ADC10CTL0 = ADC10SHT_2 + ADC10ON + ADC10IE;		// ADC10ON, interrupt enabled
	
// Analog Input Enable
// ADCAE0 - 7
	ADC10AE |= 0x02;					// P1.1 ADC option select 
}

// ============================== ADC10 interrupt =============================
// [μ] void
// ----------------------------------------------------------------------------
#pragma vector=ADC10_VECTOR
__interrupt void ADC10_ISR (void)
{
	adc10_data = ADC10MEM;					// Move results, IFG is cleared
	adc10_int_flg = 1;					// a/d data flag on
}
