// ================= MSP430F2xxx Ÿ̸_A PWM ׽Ʈ α׷ =================
//  CPU : MSP430F2012
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : IAR-MSP430
// [ ]  : ACLK : 32.768Khz
//            MCLK : DCO(16MHz)
//            SMCLK: DCO(16MHz)
// ----------------------------------------------------------------------------
// ⺻ 
#include "msp430x20x2.h"
#include <stdio.h>

//  

// Լ 
void cpu_setup(void);						// CPU ʱȭ
void Set_TimerA(void);						// Timer_A PWM 

//  

// ===============================  α׷ ==============================
// [μ]: void
// []: P1.2: CCR1 - 75% PWM     
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	_EINT();						// Enable interrupts
	
	P1DIR |= 0x0C;                       			// P1.2 and P1.3 output
	P1SEL |= 0x0C;                       			// P1.2 and P1.3 TA1/2 otions
	while(1){
		_NOP();
	}
}

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
unsigned dly;
	
	WDTCTL = WDTPW + WDTHOLD;				// Init watchdog timer(stop)
	for(dly = 0; dly < 0x4000U; dly++) ;			// XTAL  ð 
// 1MHZ  : CALBC1_1MHZ,  CALDCO_1MHZ
// 8MHZ  : CALBC1_8MHZ,  CALDCO_8MHZ
// 12MHZ : CALBC1_12MHZ, CALDCO_12MHZ
// 16MHZ : CALBC1_16MHZ, CALDCO_16MHZ
	BCSCTL1 = CALBC1_16MHZ;					// Set range(0x10f9)
	DCOCTL = CALDCO_16MHZ;					// Set DCO step + modulation(0x10f8)

	Set_TimerA();						// Timer_A PWM 
}

// =============================== TimerA PWM  ============================
// [μ] void
// [] SMCLK: 16Mhz
// ----------------------------------------------------------------------------
void Set_TimerA(void)
{
// TASSELx : Timer Clock Source SMCLK(10)
// TACLR : TimerA Clear
// MCx   : Continuos mode : The timer UP Mode(01)
	TACTL = TASSEL1 + TACLR + MC0;				// SMCLK, continous mode

	CCR0 = 512-1;						// PWM Period
	CCTL1 = OUTMOD_7;					// CCR1 reset/set
	CCR1 = 384;						// CCR1 PWM duty cycle
}
